require("recipe")
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),
 Asset( "ANIM", "anim/lr2.zip" ),
        Asset( "ANIM", "anim/rr.zip" ),

Asset( "SOUNDPACKAGE" , "sound/3.fev" ),
	Asset( "SOUND" , "sound/3.fsb" ),


}
local prefabs = {}
local start_inv = {  
    "cc", "mm"
}




local max_upgrades = 5
local function applyupgrades(inst)

        
        local upgrades = math.min(inst.level, max_upgrades)

        local hunger_percent = inst.components.hunger:GetPercent()
        local health_percent = inst.components.health:GetPercent()
       local sanity_percent = inst.components.sanity:GetPercent()

        inst.components.hunger.max = math.ceil (150 + upgrades * 10)
        inst.components.health.maxhealth = math.ceil (150 + upgrades * 10)
inst.components.sanity.max = math.ceil (160 - upgrades * 10)
     
inst.components.locomotor.walkspeed =  math.ceil (5 + upgrades * 0.4) 
	inst.components.locomotor.runspeed = math.ceil (6 + upgrades * 0.4) 
   

        inst.components.talker:Say("Lv : ".. (inst.level))
if inst.level <2 then
               

inst.components.combat:AddDamageModifier("wigfrid", -0.25)

end

if inst.level >1 and inst.level <5 then
               

inst.components.combat:AddDamageModifier("wigfrid", 0)

end
        
        if inst.level >4 then
                inst.components.talker:Say("lv : 5 Incurable")

inst.components.combat:AddDamageModifier("wigfrid", 0.25)
inst.AnimState:SetBuild("lr2")

inst.soundsname = "wendy"

inst.components.eater:SetCarnivore(true)


        end

        inst.components.hunger:SetPercent(hunger_percent)
        inst.components.health:SetPercent(health_percent)
       inst.components.sanity:SetPercent(sanity_percent)
end


local function updatestats(inst)

    if GetClock():GetMoonPhase() == "full" and inst.level <5
then
		
		
 inst.level = inst.level + 1
 SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())


 applyupgrades(inst)
	inst.SoundEmitter:PlaySound("3/3/3")	
	end
	end

local function onkill(inst, data)




    
    if math.random() < 0.03 and inst.level < 4 then
        inst.level = inst.level + 1
 SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())

     

    

 applyupgrades(inst)
   

       
        inst.SoundEmitter:PlaySound("3/3/3")

        --icon pulse while upgrading
        inst.HUD.controls.status.heart:PulseGreen()
        inst.HUD.controls.status.stomach:PulseGreen()
        inst.HUD.controls.status.brain:PulseGreen()
            
        inst.HUD.controls.status.brain:ScaleTo(1.3,1,.7)
        inst.HUD.controls.status.heart:ScaleTo(1.3,1,.7)
        inst.HUD.controls.status.stomach:ScaleTo(1.3,1,.7)
    end
end

local function oneat(inst, food)
if food and food.components.edible and food.prefab == "fs" and inst.level > 0 then
		--give an upgrade! 

		inst.level = inst.level - 1
inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		applyupgrades(inst)
             
	end
end

local function sanitylow(inst, data)

		if inst.components.sanity.current <= 50 and inst.level <5 then

	inst.soundsname = "wendy"

inst.components.combat:AddDamageModifier("wigfrid", 0.25)
inst.AnimState:SetBuild("lr2")
			end

		if inst.components.sanity.current > 50 and inst.level <2 then
inst.components.combat:AddDamageModifier("wigfrid", -0.25)
inst.soundsname = "rr"
			
inst.AnimState:SetBuild("rr")
		end

if inst.components.sanity.current > 50 and inst.level >1 and inst.level <5 then
inst.components.combat:AddDamageModifier("wigfrid", 0)
inst.soundsname = "rr"			
inst.AnimState:SetBuild("rr")
		end

if inst.components.health:GetPercent() < .5 and inst.level >4  then
inst.Light:Enable(true)
end
if inst.components.health:GetPercent() > .5  then
inst.Light:Enable(false)
end
		end



local function onpreload(inst, data)
        if data then
                if data.level then
                        inst.level = data.level

                        applyupgrades(inst)
                        --re-set these from the save data, because of load-order clipping issues
                        if data.health and data.health.health then inst.components.health.currenthealth = data.health.health end
                        if data.hunger and data.hunger.hunger then inst.components.hunger.current = data.hunger.hunger end
                        if data.sanity and data.sanity.current then inst.components.sanity.current = data.sanity.current end
                        inst.components.health:DoDelta(0)
                        inst.components.hunger:DoDelta(0)
                        inst.components.sanity:DoDelta(40)
                end
        end

end

local function onsave(inst, data)
        data.level = inst.level
data.charge_time = inst.charge_time
end




local fn = function(inst)

inst.Transform:SetScale(1.3,1.3,1.3)



    
    inst.MiniMapEntity:SetIcon( "rr.tex" )
        inst.components.health.absorb = 0
        inst.level = 0
        applyupgrades(inst)

    -- Damage multiplier (optional)

    
    -- Movement speed (optional)
    inst.components.locomotor.walkspeed = 5
    inst.components.locomotor.runspeed = 6
inst.components.health:SetMaxHealth(150)
	inst.components.hunger:SetMax(150)
	inst.components.sanity:SetMax(160)
    inst.OnSave = onsave
    inst.OnPreLoad = onpreload

inst.components.eater:SetOnEatFn(oneat)

inst.entity:AddLight()
		inst.Light:SetRadius(1)
		inst.Light:SetFalloff(1)
		inst.Light:SetIntensity(.5)
		inst.Light:SetColour(255/255,2/255,2/255)

    -- lower profit from non-meat food

    inst:ListenForEvent("entity_death", function(wrld, data) onkill(inst, data) end, GetWorld())

inst:ListenForEvent("hungerdelta", sanitylow)

local mm = Recipe("mm", {Ingredient("petals", 3), Ingredient("strawhat", 1), Ingredient("cutreeds", 8)}, RECIPETABS.DRESS, TECH.NONE)
    mm.atlas = "images/inventoryimages/mm.xml"


  local cc = Ingredient( "cc", 1)
    cc.atlas = "images/inventoryimages/cc.xml"
 local fs = Recipe("fs", {Ingredient("petals", 3), Ingredient("nightmarefuel", 2), Ingredient("honey", 3)}, RECIPETABS.SURVIVAL, {SCIENCE = 2})
 fs.atlas = "images/inventoryimages/fs.xml"
    local xx = Recipe("xx", {cc, Ingredient("petals_evil", 5), Ingredient("nightmarefuel", 5)}, RECIPETABS.WAR, {SCIENCE = 1})
    xx.atlas = "images/inventoryimages/xx.xml"

    local xx = Ingredient( "xx", 1)
    xx.atlas = "images/inventoryimages/xx.xml"

   

 
   cc.atlas = "images/inventoryimages/cc.xml"

   



inst:ListenForEvent( "nighttime", function() updatestats(inst) end , GetWorld())
	updatestats(inst)

end


return MakePlayerCharacter("rr", prefabs, assets, fn, start_inv)
